var _ctor, exec, sys;
var __bind = function(func, context) {
    return function(){ return func.apply(context, arguments); };
  }, __hasProp = Object.prototype.hasOwnProperty;
sys = require("sys");
exec = require("child_process").exec;
exports.Displayer = (function() {
  _ctor = function(_arg) {
    this.args = _arg;
    this.task = this.args[2];
    this.servers = {};
    this.jobIndex = 1;
    this.jobIndexDone = 0;
    this.startTime = +new Date();
    process.on("exit", __bind(function() {
      var duration;
      duration = +new Date() - this.startTime;
      return console.log("\n\033[0;30mcapoo: \033[1;37;40m " + (this.task) + " \033[0;32m done in \033[1;32m" + ((duration / 1000).toFixed(1)) + " seconds!\033[m");
    }, this));
    return this;
  };
  _ctor.prototype.updateScreen = function() {
    var _ref, _result, data, host;
    sys.print("\033[2J");
    sys.print("\033[0;30mcapoo: \033[1;37mRunning capistrano task \033[1;37;40m " + (this.task) + " \033[m\n");
    if (this.command) {
      sys.print("\033[0;30mcapoo: \033[1;37mExecuting command: \033[1;37;40m " + (this.command) + " \033[m\n");
    }
    sys.print("\n");
    _result = []; _ref = this.servers;
    for (host in _ref) {
      if (!__hasProp.call(_ref, host)) continue;
      data = _ref[host];
      _result.push(sys.print("\033[0;30m" + (host) + ":\t\033[1;" + (data.done === true ? 32 : 37) + "m " + (data.message) + "\033[m\n"));
    }
    return _result;
  };
  _ctor.prototype.parseData = function(data) {
    var _i, _len, _ref, host, line, match, matches, server, servers;
    if (match = data.match(/servers: (.*)/i)) {
      servers = JSON.parse(match[1]);
      _ref = servers;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        server = _ref[_i];
        this.servers[server] = {
          message: "Connecting...",
          done: false,
          job: this.jobIndex
        };
      }
      this.jobIndex++;
    }
    if (matches = data.match(/\*\* \[out :: (.*)\] (.*)/ig)) {
      _ref = matches;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        line = _ref[_i];
        match = line.match(/\*\* \[out :: (.*)\] (.*)/i);
        if (this.servers[match[1]]) {
          this.servers[match[1]].message = match[2];
        } else {
          this.servers[match[1]] = {
            message: match[2]
          };
        }
      }
    }
    if (match = data.match(/\* executing \"(.*)\"/i)) {
      this.command = match[1];
    }
    if (match = data.match(/command finished/i)) {
      _ref = this.servers;
      for (host in _ref) {
        if (!__hasProp.call(_ref, host)) continue;
        data = _ref[host];
        if (data.job === this.jobIndexDone + 1) {
          this.servers[host].done = true;
        }
      }
      this.jobIndexDone++;
    }
    return this.updateScreen();
  };
  _ctor.prototype.run = function() {
    this.process = exec("cap " + (this.task));
    this.process.stdout.on("data", __bind(function(data) {
      return console.log(data.toString());
    }, this));
    return this.process.stderr.on("data", __bind(function(data) {
      return this.parseData(data.toString());
    }, this));
  };
  return _ctor;
})();